/*

  Doom 64 Macro Compiler

  Copyright 2008 James Haley

  haleyjd@hotmail.com

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#ifndef MACRODATA_H__
#define MACRODATA_H__

typedef unsigned char byte;

#ifdef _MSC_VER
   #define strcasecmp  _stricmp
   #define strncasecmp _strnicmp
#endif

struct MacroHeader
{
   int macrocount;    // # of macros defined
   int commandcount; // total # of commands
};

struct MacroCommand
{
   int batchid;     // batch id #
   int linetag;     // line tag or special data
   int linespecial; // line special #
};

struct Macro
{
   int commandcount;   // # of commands in macro
   int commandsalloc;  // for use by script parser
   MacroCommand *cmds; // array of commands (count + 1)
};

extern MacroHeader  header;
extern Macro       *macros;

void LoadMacros(const char *fn);
void DecompileMacros(const char *fn);
void WriteMacros(const char *fn);
void LoadScript(const char *fn);

#endif

// EOF

