/*

  Doom 64 Macro Compiler

  Copyright 2008 James Haley

  haleyjd@hotmail.com

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include <exception>
#include <cctype>

using namespace std;

//
// StringHash
//
// General string hash routine.
//
unsigned int StringHash(const char *str)
{
   const char  *c = str;
   unsigned int h = 0;

   if(!str)
      throw exception("Cannot hash NULL string");

   while(*c)
   {
      h = 5 * h + toupper(*c);
      ++c;
   }

   return h;
}

// EOF

